#include <dos.h>
#include <conio.h>
#include <stdio.h>
#include <stdlib.h>
#include <ctype.h>
#include <string.h>
#define TRUE -1
#define FALSE 0

unsigned int BASE=0x300;
unsigned char jumpers;
unsigned char adrange;
unsigned char dacBrange;
unsigned char dacArange;

//sbitd takes data and bit, then returns 0x81 or 0x01 based on data[bit]
unsigned char sbitd(unsigned int data,unsigned char bit)
{
  return (data & (1<<bit))?0x81:0x01;
}

void EEPROM_Enable(void)
{
  outportb(BASE+0x18,0x80);//start process
  outportb(BASE+0x18,0x81);//start bit
  outportb(BASE+0x18,0x01);//Opcode bit 0 (00 = enable/disable)
  outportb(BASE+0x18,0x01);//Opcode bit 1  ""
  outportb(BASE+0x18,0x81);//a5 (must be 1 to enable)
  outportb(BASE+0x18,0x81);//a4 (must be 1 to enable)
  outportb(BASE+0x18,0x01);//a3 (don't care because enable/disable)
  outportb(BASE+0x18,0x01);//a2 (don't care because enable/disable)
  outportb(BASE+0x18,0x01);//a1 (don't care because enable/disable)
  outportb(BASE+0x18,0x01);//a0 (don't care because enable/disable)
  outportb(BASE+0x18,0x00);//end trans
}

void EEPROM_Disable(void)
{
  outportb(BASE+0x18,0x80);//start process
  outportb(BASE+0x18,0x81);//start bit
  outportb(BASE+0x18,0x01);//Opcode bit 0 (00 = enable/disable)
  outportb(BASE+0x18,0x01);//Opcode bit 1  ""
  outportb(BASE+0x18,0x01);//a5 (must be 0 to disable)
  outportb(BASE+0x18,0x01);//a4 (must be 0 to disable)
  outportb(BASE+0x18,0x01);//a3 (don't care because enable/disable)
  outportb(BASE+0x18,0x01);//a2 (don't care because enable/disable)
  outportb(BASE+0x18,0x01);//a1 (don't care because enable/disable)
  outportb(BASE+0x18,0x01);//a0 (don't care because enable/disable)
  outportb(BASE+0x18,0x00);//end trans
}

unsigned int EEPROM_Read(unsigned int addr)
{
  unsigned int data=0;
  outportb(BASE+0x18,0x80);//start process
  outportb(BASE+0x18,0x81);//Start Bit
  outportb(BASE+0x18,0x81);//Opcode Bit 0 (10=Read)
  outportb(BASE+0x18,0x01);//Opcode Bit 1  ""
  outportb(BASE+0x18,sbitd(addr,5));//a5 (address to write to)
  outportb(BASE+0x18,sbitd(addr,4));//a4
  outportb(BASE+0x18,sbitd(addr,3));//a3
  outportb(BASE+0x18,sbitd(addr,2));//a2
  outportb(BASE+0x18,sbitd(addr,1));//a1
  outportb(BASE+0x18,sbitd(addr,0));//a0
//  delay(10);
//  inportb(BASE+0x18);//dummy bit
  data=(data<<1) | ((inportb(BASE+0x18) & 0x80)?1:0);//d15
  data=(data<<1) | ((inportb(BASE+0x18) & 0x80)?1:0);//d14
  data=(data<<1) | ((inportb(BASE+0x18) & 0x80)?1:0);//d13
  data=(data<<1) | ((inportb(BASE+0x18) & 0x80)?1:0);//d12
  data=(data<<1) | ((inportb(BASE+0x18) & 0x80)?1:0);//d11
  data=(data<<1) | ((inportb(BASE+0x18) & 0x80)?1:0);//d10
  data=(data<<1) | ((inportb(BASE+0x18) & 0x80)?1:0);//d9
  data=(data<<1) | ((inportb(BASE+0x18) & 0x80)?1:0);//d8
  data=(data<<1) | ((inportb(BASE+0x18) & 0x80)?1:0);//d7
  data=(data<<1) | ((inportb(BASE+0x18) & 0x80)?1:0);//d6
  data=(data<<1) | ((inportb(BASE+0x18) & 0x80)?1:0);//d5
  data=(data<<1) | ((inportb(BASE+0x18) & 0x80)?1:0);//d4
  data=(data<<1) | ((inportb(BASE+0x18) & 0x80)?1:0);//d3
  data=(data<<1) | ((inportb(BASE+0x18) & 0x80)?1:0);//d2
  data=(data<<1) | ((inportb(BASE+0x18) & 0x80)?1:0);//d1
  data=(data<<1) | ((inportb(BASE+0x18) & 0x80)?1:0);//d0
  outportb(BASE+0x18,0x00);//end com
  return data;
}

void CAL_ADC(unsigned char M,unsigned char B)
{ //write cal to A/D, offset first, then slope
  outportb(BASE+0x19,0x80);//start process
  outportb(BASE+0x19,0x01);//a1 pot 00 is offset
  outportb(BASE+0x19,0x01);//a0 ""
  outportb(BASE+0x19,sbitd(B,7));//data bit 7 of offset
  outportb(BASE+0x19,sbitd(B,6));//data bit 6 of offset
  outportb(BASE+0x19,sbitd(B,5));//data bit 5 of offset
  outportb(BASE+0x19,sbitd(B,4));//data bit 4 of offset
  outportb(BASE+0x19,sbitd(B,3));//data bit 3 of offset
  outportb(BASE+0x19,sbitd(B,2));//data bit 2 of offset
  outportb(BASE+0x19,sbitd(B,1));//data bit 1 of offset
  outportb(BASE+0x19,sbitd(B,0));//data bit 0 of offset
  outportb(BASE+0x19,0x00);//end trans
  delay(1);
  //write slope now
  outportb(BASE+0x19,0x80);//start process
  outportb(BASE+0x19,0x01);//a1 pot 01 is slope of A/D
  outportb(BASE+0x19,0x81);//a0 pot 01 is slope of A/D
  outportb(BASE+0x19,sbitd(M,7));//data bit 7 of slope
  outportb(BASE+0x19,sbitd(M,6));//data bit 6 of slope
  outportb(BASE+0x19,sbitd(M,5));//data bit 5 of slope
  outportb(BASE+0x19,sbitd(M,4));//data bit 4 of slope
  outportb(BASE+0x19,sbitd(M,3));//data bit 3 of slope
  outportb(BASE+0x19,sbitd(M,2));//data bit 2 of slope
  outportb(BASE+0x19,sbitd(M,1));//data bit 1 of slope
  outportb(BASE+0x19,sbitd(M,0));//data bit 0 of slope
  outportb(BASE+0x19,0x00);//end trans
}

void CAL_DAC(unsigned char DACNum,unsigned char M)
{
  //PCICARDs use +1A instead of +19, and the A1 bit needs to be cleared
  //we can read BASE+0x1F to determine if its the PCI card or not.  PCI==0
  unsigned PCICARD=(inportb(BASE+0x1F)==0x00) ? 1 : 0;

  outportb(BASE+0x19+PCICARD,0x80);//start process
  outportb(BASE+0x19+PCICARD,PCICARD?0x01:0x81 );
  outportb(BASE+0x19+PCICARD,sbitd(DACNum,0));//a0 pot 11 is slope of DAC1
  outportb(BASE+0x19+PCICARD,sbitd(M,7));//data bit 7 of slope
  outportb(BASE+0x19+PCICARD,sbitd(M,6));//data bit 6 of slope
  outportb(BASE+0x19+PCICARD,sbitd(M,5));//data bit 5 of slope
  outportb(BASE+0x19+PCICARD,sbitd(M,4));//data bit 4 of slope
  outportb(BASE+0x19+PCICARD,sbitd(M,3));//data bit 3 of slope
  outportb(BASE+0x19+PCICARD,sbitd(M,2));//data bit 2 of slope
  outportb(BASE+0x19+PCICARD,sbitd(M,1));//data bit 1 of slope
  outportb(BASE+0x19+PCICARD,sbitd(M,0));//data bit 0 of slope
  outportb(BASE+0x19+PCICARD,0x00);//end trans
}

void CAL(void)
{
  unsigned char zDAM, zDBM, zAM, zAB;

  zAB=EEPROM_Read((adrange+0))&0xff;  //byte 0-7 in EEPROM holds "B" for ADC
  zAM=EEPROM_Read((adrange+8))&0xff;  //byte 8-f in EEPROM holds "M" for ADC
  zDAM=EEPROM_Read((dacArange+0x10))&0xff; //byte x10,x11 in EEPROM holds "M" for DAC0
  zDBM=EEPROM_Read((dacBrange+0x12))&0xff; //byte x12,x13 in EEPROM holds "M" for DAC1
  CAL_DAC(0,zDAM);//write the calibration value from EEPROM to CAL Pots
  CAL_DAC(1,zDBM);// ""
  CAL_ADC(zAM,zAB);// ""
}


unsigned AskForBaseAddress(unsigned int OldOne)
{
	char msg[8];
	unsigned int NewOne = 0, Success = 0, Dummy;
	int AddrInputPosX, AddrInputPosY;

	puts("Please enter the Base Address (100-FFFF) for your card (in hex)");
	printf("or press ENTER for %X.\n>", OldOne);
	AddrInputPosX = wherex(); AddrInputPosY = wherey();
	do {
		gotoxy(AddrInputPosX, AddrInputPosY);
		clreol();
		msg[0] = 5; msg[1] = 0;
		cgets(msg);
		sscanf(msg + 2, "%x", &NewOne);
		if (NewOne >= 0x100)
		{
			Success = 1;
			Dummy = NewOne;
		} else if (msg[1] == 0) {
			gotoxy(AddrInputPosX, AddrInputPosY);
			printf("%X", OldOne);
			Success = 1;
			Dummy = OldOne;
		}
	} while(!Success);
	return (Dummy);
} /* end of AskForBaseAddress */


void main(void)
{
  clrscr();
  cputs("This calibration utility needs the address of your A/D card to run.\n\r");
  BASE = AskForBaseAddress(BASE);
  cputs("\r\n");
  jumpers=inportb(BASE+0x12);//jumper configuration readback
  adrange=jumpers & 0x07;//d2,d1,d0 are 5/10, uni/bip, 16/8
  dacBrange=(jumpers>>3) & 0x01;//d4,d3 are 5/10 for daca,b
  dacArange=(jumpers>>4) & 0x01;


  cputs("\r\nThis utility initializes the calibration circuit with the values\r\n");
  cputs("previously stored in the card for the configured ranges:\r\n");
  cprintf("A/D:   %s %s\r\n"
          "DAC A: %s\r\n"
          "DAC B: %s",
          (adrange&0x01)?
          ((adrange&0x04)?"5V":"10V")
          :
          ((adrange&0x04)?"0-10V":"0-10V(Low Res)") //0-10V(Low Res) is
          ,                                           //in theory 0-20V,
          (adrange&0x02)?"16ch":"8ch",                //but the amps cap
          dacArange?"0-5V":"0-10V",                   //at 10V
          dacBrange?"0-5V":"0-10V"
  );
  textattr(0x07);
  CAL();
  cputs("\r\n\nDone.\r\n");
}

/**/
